package org.jboss.soa.esb.devcon2009;

import org.apache.log4j.Logger;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;

/***
 * @author pmacik@redhat.com
 */
public class LoggingAction extends AbstractActionLifecycle {

   private static final Logger log = Logger.getLogger(LoggingAction.class);
   private ConfigTree _config;

   public LoggingAction(ConfigTree config) {
      this._config = config;
   }

   public Message process(Message message) throws Exception {
      String loggingMessage = _config.getAttribute("message");
      if(loggingMessage != null){
         log.info(loggingMessage);
      }else{
         log.warn("No 'message' property defined...");
      }
      return message;
   }

   public void exceptionHandler() {
   }
}
