package org.jboss.soa.esb.devcon2009;

import org.apache.log4j.Logger;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.helpers.Email;
import org.jboss.soa.esb.message.Message;

public class SendEmailAction extends AbstractActionLifecycle {

   private static final Logger log = Logger.getLogger(SendEmailAction.class);
   private ConfigTree config_;

   public SendEmailAction(ConfigTree config) {
      this.config_ = config;
   }

   public Message send(Message message) throws Exception {

      String to = config_.getAttribute("to");
      String from = config_.getAttribute("from");
      String subject = config_.getAttribute("subject");
      String msg = config_.getAttribute("message");

      log.info("============================================");
      log.info("From: " + from);
      log.info("To: " + to);
      log.info("Subject: " + subject);
      log.info("------");
      log.info(msg);
      log.info("============================================");

      Email sender = new Email();
      sender.setFrom(from);
      sender.setSendTo(to);
      sender.setSubject(subject);
      sender.setMessage(msg);
      sender.sendMessage();

      return message;
   }
}
