package org.jboss.soa.esb.devcon2009;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import org.apache.log4j.Logger;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.util.XPathUtil;
import org.w3c.dom.Element;

/***
 * @author pmacik@redhat.com
 */
public class SubmitOrderAction extends AbstractActionLifecycle {

   private static final Logger log = Logger.getLogger(SubmitOrderAction.class);
   private ConfigTree config_;

   public SubmitOrderAction(ConfigTree config) {
      this.config_ = config;
   }

   public Message submitOrder(Message message) throws Exception {
      String orderXML = new String((byte[]) message.getBody().get());
      Element item = XPathUtil.getNodeFromXPathExpression(orderXML, "/order/item");
      int id = Integer.valueOf(item.getAttribute("id"));
      int count = Integer.valueOf(item.getAttribute("count"));
      Connection sqlConn = null;
      PreparedStatement stmt = null;
      try {
         Class.forName("com.mysql.jdbc.Driver");
         String url = "jdbc:mysql://lajka:3306/devcon2009";

         sqlConn = DriverManager.getConnection(url, "jbesb", "jbesbpass");
         stmt = sqlConn.prepareStatement("insert into orders values (?, ?, ?);");


         if (stmt != null) {
            stmt.setLong(1, System.currentTimeMillis());
            stmt.setInt(2, id);
            stmt.setInt(3, count);
         } else {
            throw new Exception("Preparing statement failed");
         }

         stmt.executeUpdate();
      } catch (Exception e) {
         log.error(e);
         return null;
      } finally {
         stmt.close();
         sqlConn.close();
      }

      return message;
   }

   public void exceptionHandler() {
   }
}
